searchNodes=[{"doc":"A DSL for Benchee .","ref":"BencheeDsl.html","title":"BencheeDsl","type":"module"},{"doc":"Configures benchee .","ref":"BencheeDsl.html#config/1","title":"BencheeDsl.config/1","type":"function"},{"doc":"Runs the benchmarks.","ref":"BencheeDsl.html#run/1","title":"BencheeDsl.run/1","type":"function"},{"doc":"Helpers for defining a benchmark with the DSL. This module must be used to define and configure a benchmark.","ref":"BencheeDsl.Benchmark.html","title":"BencheeDsl.Benchmark","type":"behaviour"},{"doc":"Configures the benchmark.","ref":"BencheeDsl.Benchmark.html#config/1","title":"BencheeDsl.Benchmark.config/1","type":"macro"},{"doc":"Adds a formatter to the benchmark.","ref":"BencheeDsl.Benchmark.html#formatter/2","title":"BencheeDsl.Benchmark.formatter/2","type":"macro"},{"doc":"Defines a function or map to setup the inputs for the benchmark. If inputs has a do block a map is expected to be returned.","ref":"BencheeDsl.Benchmark.html#inputs/1","title":"BencheeDsl.Benchmark.inputs/1","type":"macro"},{"doc":"This macro defines a function for the benchmark.","ref":"BencheeDsl.Benchmark.html#job/1","title":"BencheeDsl.Benchmark.job/1","type":"macro"},{"doc":"","ref":"BencheeDsl.Benchmark.html#job/2","title":"BencheeDsl.Benchmark.job/2","type":"macro"},{"doc":"","ref":"BencheeDsl.Benchmark.html#job/3","title":"BencheeDsl.Benchmark.job/3","type":"macro"},{"doc":"Overwrites the job map. This function can be used to set up jobs dynamically.","ref":"BencheeDsl.Benchmark.html#jobs/1","title":"BencheeDsl.Benchmark.jobs/1","type":"macro"},{"doc":"Updates the job map. This function can be used to set up jobs dynamically.","ref":"BencheeDsl.Benchmark.html#jobs/2","title":"BencheeDsl.Benchmark.jobs/2","type":"macro"},{"doc":"Creates a new Benchmark struct.","ref":"BencheeDsl.Benchmark.html#new/1","title":"BencheeDsl.Benchmark.new/1","type":"function"},{"doc":"Defines a callback that runs once the benchmark exits.","ref":"BencheeDsl.Benchmark.html#on_exit/1","title":"BencheeDsl.Benchmark.on_exit/1","type":"macro"},{"doc":"Runs the benchmark.","ref":"BencheeDsl.Benchmark.html#c:run/0","title":"BencheeDsl.Benchmark.run/0","type":"callback"},{"doc":"Runs the benchmark with the given config .","ref":"BencheeDsl.Benchmark.html#c:run/1","title":"BencheeDsl.Benchmark.run/1","type":"callback"},{"doc":"Defines a setup callback to be run before the benchmark starts.","ref":"BencheeDsl.Benchmark.html#setup/1","title":"BencheeDsl.Benchmark.setup/1","type":"macro"},{"doc":"Updates a benchmark struct by the given key or path .","ref":"BencheeDsl.Benchmark.html#update/3","title":"BencheeDsl.Benchmark.update/3","type":"function"},{"doc":"","ref":"BencheeDsl.Benchmark.html#t:keys/0","title":"BencheeDsl.Benchmark.keys/0","type":"type"},{"doc":"","ref":"BencheeDsl.Benchmark.html#t:t/0","title":"BencheeDsl.Benchmark.t/0","type":"type"},{"doc":"Start and runs the benchmarks.","ref":"Mix.Tasks.Bench.html","title":"Mix.Tasks.Bench","type":"task"},{"doc":"Generates basic benchmark structure.","ref":"Mix.Tasks.Bench.Gen.html","title":"Mix.Tasks.Bench.Gen","type":"task"},{"doc":"BencheeDsl provides a DSL to write benchmarks for Benchee . For now, just an early alpha version.","ref":"readme.html","title":"BencheeDsl","type":"extras"},{"doc":"First, add benchee and benchee_dsl to your mix.exs dependencies: def deps do [ { :benchee , &quot;~&gt; 1.0.0&quot; , only : :dev } , { :benchee_dsl , &quot;~&gt; 0.1.0&quot; , only : :dev } ] end Then, update your dependencies: $ mix deps.get","ref":"readme.html#installation","title":"BencheeDsl - Installation","type":"extras"},{"doc":"Generate the bench directory, the bench/benchee_helper.exs , and the example bench/example_bench.exs with: $ mix bench.gen Create directory bench. Write &#39;bench/benchee_helper.exs&#39;. Write &#39;bench/example_bench.exs&#39;. Start the benchmark with: $ mix bench ... Benchmarking flat_map with input Bigger... Benchmarking flat_map with input Medium... Benchmarking flat_map with input Small... Benchmarking map_flatten with input Bigger... Benchmarking map_flatten with input Medium... Benchmarking map_flatten with input Small... ...","ref":"readme.html#usage","title":"BencheeDsl - Usage","type":"extras"},{"doc":"In the standard configuration the benchmarks are stored in the bench directory. The benchmarks are saved in a file with the ending _bench.exs . The example benchmark: defmodule ExampleBench do use BencheeDsl.Benchmark config time : 1 inputs %{ &quot;Small&quot; =&gt; Enum . to_list ( 1 .. 1_000 ) , &quot;Medium&quot; =&gt; Enum . to_list ( 1 .. 10_000 ) , &quot;Bigger&quot; =&gt; Enum . to_list ( 1 .. 100_000 ) } job flat_map ( input ) do Enum . flat_map ( input , &amp; map_fun / 1 ) end job map_flatten ( input ) do input |&gt; Enum . map ( &amp; map_fun / 1 ) |&gt; List . flatten ( ) end def map_fun ( i ) , do : [ i , i * i ] end Adding a formatter defmodule ExampleBench do use BencheeDsl.Benchmark config time : 1 formatter Benchee.Formatters.Markdown , file : Path . expand ( &quot;example.md&quot; , __DIR__ ) , description : &quot;&quot;&quot; Bla bla bla ... &quot;&quot;&quot; inputs %{ &quot;Small&quot; =&gt; Enum . to_list ( 1 .. 1_000 ) , &quot;Medium&quot; =&gt; Enum . to_list ( 1 .. 10_000 ) , &quot;Bigger&quot; =&gt; Enum . to_list ( 1 .. 100_000 ) } job flat_map ( input ) do Enum . flat_map ( input , &amp; map_fun / 1 ) end job map_flatten ( input ) do input |&gt; Enum . map ( &amp; map_fun / 1 ) |&gt; List . flatten ( ) end def map_fun ( i ) , do : [ i , i * i ] end inputs with do block defmodule ExampleBench do use BencheeDsl.Benchmark config time : 1 inputs do data = data . json |&gt; File . read! ( ) |&gt; Jason . decode ( ) %{ &quot;Small&quot; =&gt; Map . get ( data , &quot;small&quot; ) , &quot;Medium&quot; =&gt; Map . get ( data , &quot;medium&quot; ) , &quot;Bigger&quot; =&gt; Map . get ( data , &quot;bigger&quot; ) } end job flat_map ( input ) do Enum . flat_map ( input , &amp; map_fun / 1 ) end job map_flatten ( input ) do input |&gt; Enum . map ( &amp; map_fun / 1 ) |&gt; List . flatten ( ) end def map_fun ( i ) , do : [ i , i * i ] end job delgates Jobs can be delegated to functions. In this case, the input must be a list with the length of the function's arity. defmodule Foo do def flat_map ( a , b ) do a |&gt; data ( b ) |&gt; Enum . flat_map ( &amp; map_fun / 1 ) end def map_flatten ( a , b ) do a |&gt; data ( b ) |&gt; Enum . map ( &amp; map_fun / 1 ) |&gt; List . flatten ( ) end def data ( a , b ) , do : Enum . to_list ( a .. b ) def map_fun ( i ) , do : [ i , i * i ] end defmodule DelegateBench do use BencheeDsl.Benchmark inputs %{ &quot;small&quot; =&gt; [ 1 , 100 ] , &quot;medium&quot; =&gt; [ 1 , 10_000 ] , &quot;bigger&quot; =&gt; [ 1 , 100_000 ] } job &amp; Foo . map_flatten / 2 job &amp; Foo . flat_map / 2 end @before Jobs tagged with @before are getting a function to transform the input. The following example can be found at example/sets . defmodule AddBench do use BencheeDsl.Benchmark inputs do small = 1 .. 10 medium = 1 .. 1_000 large = 1 .. 100_000 small_int_list = Enum . to_list ( small ) medium_int_list = Enum . to_list ( medium ) large_int_list = Enum . to_list ( large ) small_bin_list = Enum . map ( small , fn _ -&gt; :crypto . strong_rand_bytes ( 10 ) end ) medium_bin_list = Enum . map ( medium , fn _ -&gt; :crypto . strong_rand_bytes ( 10 ) end ) large_bin_list = Enum . map ( large , fn _ -&gt; :crypto . strong_rand_bytes ( 10 ) end ) %{ &quot;small eq int&quot; =&gt; [ 15 , small_int_list ] , &quot;medium eq int&quot; =&gt; [ 1500 , medium_int_list ] , &quot;large eq int&quot; =&gt; [ 150_000 , large_int_list ] , &quot;small eq bin&quot; =&gt; [ :crypto . strong_rand_bytes ( 10 ) , small_bin_list ] , &quot;medium eq bin&quot; =&gt; [ :crypto . strong_rand_bytes ( 10 ) , medium_bin_list ] , &quot;large eq bin&quot; =&gt; [ :crypto . strong_rand_bytes ( 10 ) , large_bin_list ] } end @before fn [ arg1 , arg2 ] -&gt; [ arg1 , :gb_sets . from_list ( arg2 ) ] end job &amp; :gb_sets . add_element / 2 @tag :skip @before fn [ arg1 , arg2 ] -&gt; [ arg1 , :sets . from_list ( arg2 ) ] end job &amp; :sets . add_element / 2 @before fn [ arg1 , arg2 ] -&gt; [ arg1 , :ordsets . from_list ( arg2 ) ] end job &amp; :ordsets . add_element / 2 end setup, on_exit defmodule ExampleBench do use BencheeDsl.Benchmark require Logger setup do Logger . info ( &quot;Starting benchmark&quot; ) on_exit fn -&gt; Logger . info ( &quot;Ready.&quot; ) end end config time : 1 inputs %{ &quot;Small&quot; =&gt; Enum . to_list ( 1 .. 1_000 ) , &quot;Medium&quot; =&gt; Enum . to_list ( 1 .. 10_000 ) , &quot;Bigger&quot; =&gt; Enum . to_list ( 1 .. 100_000 ) } job flat_map ( input ) do Enum . flat_map ( input , &amp; map_fun / 1 ) end job map_flatten ( input ) do input |&gt; Enum . map ( &amp; map_fun / 1 ) |&gt; List . flatten ( ) end def map_fun ( i ) , do : [ i , i * i ] end","ref":"readme.html#writing-benchmarks","title":"BencheeDsl - Writing benchmarks","type":"extras"}]